<?php
/**
 * @package		Joomla
 * @subpackage p8 twitter module
 * @copyright	Pollen 8 Design Ltd 2005 - 2009. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class modP8TwitterHelper
{
  function getList(&$params)
  {
    $limit = $params->get('numtweets', 10);
    $db =& JFactory::getDBO();
    $db->setQuery("SELECT * FROM #__p8twitter_lists WHERE id = " . (int)$params->get('data'));
    $row = $db->loadObject();
    $row->parameters	= new JParameter( $row->attribs );
    require_once( JPATH_BASE.DS.'components'.DS.'com_p8twitter'.DS.'libs'.DS.'class.twitter.php' );
    $api = new twitter();
    $config =& JComponentHelper::getParams( 'com_p8twitter' );
    $api->username  = $config->get('username');
    $api->password = $config->get('password');
    $method = $row->twitter_view;
    $userid = $row->twitter_users;
    if($method == 'searchresults'){
       $search = JRequest::getVar('twitter_search', $row->parameters->get('twitter_search'));
	    JRequest::setVar( 'twitter_search', $search );
      $data =& $api->search( );
    }else{
      $data =& $api->$method( $userid );
    }
    modP8TwitterHelper::hrefURLS( $data );

    $return = array('data'=>array(), 'layout'=> 'default_' . 	$row->twitter_view );
    $c = 1;
    foreach ($data as $d) {
      $return['data'][] = $d;
      if ($c >= $limit) {
        return $return;
      }
      $c ++;
       
    }
    return $return;

  }
  
  function getSearchData()
  {

    require_once( JPATH_COMPONENT.DS.'libs'.DS.'class.twitter.php' );
    $api = new twitter();
    $config =& JComponentHelper::getParams( 'com_p8twitter' );
    $api->username  = $config->get('username');
    $api->password = $config->get('password');

      
    $searchData = $api->search();
    $this->hrefURLS( $this->searchData );

    return $searchData;
  }

  function hrefURLS(&$d)
  {
    foreach ($d as &$data) {
      $data->text = preg_replace("/(([a-z][A-z]+:\/\/)([a-zA-Z0-9?&%.;:\/=+_-]*))/", "<a href=\"$1\" target=\"_blank\">$1</a>", @$data->text);
    }
  }


}