<?php
/**
 * @package Joomla
 * @subpackage p8Twitter
 * @copyright Copyright (C) 2009 Rob Clayburn. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

/**
 *
 * All rights reserved
 * Joomla! is Free Software
 * License: http://www.gnu.org/copyleft/gpl.html
 *
 * @package p8Twitter
 * @Copyright (C) Rob Clayburn
 * @version $Revision: 1.8 $
 *
 */

class p8twitterModelTweets extends JModel {
 
  
  /** @var data requested by component */
  var $data = null;
  
  var $_navLimit = 10;

  
	function getData()
	{
		if (!isset( $this->data )) {
			$user					=& JFactory::getUser();
			$query 				= "SELECT id, name, twitter_view FROM `#__p8twitter_lists`";
			$limit				= JRequest::getVar( 'limit', $this->_navLimit, '', 'int' );
			$limitstart		= JRequest::getVar( 'limitstart', 0, '', 'int' );
			$this->data = $this->_getList( $query, $limitstart, $limit );
		}
		return $this->data;
	}

}?>